/*------------------------------------------------------------------------------
#
#	Apple Macintosh Developer Technical Support
#
#	MultiFinder-Aware Simple Sample Application
#
#	Sample
#
#	Sample.r	-	Rez Source
#
#	Copyright  1989-1991 Apple Computer, Inc.
#	All rights reserved.
#
#	Versions:
#				1.00				08/88
#				1.01				11/88
#				1.02				04/89	MPW 3.1
#				2.00				02/91	7.0 Happy
#
------------------------------------------------------------------------------*/


#include "Types.r"
#include "SysTypes.r"
#include "BalloonTypes.r"
#include "Sample.h"


/* we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenuBar, preload) {
	{ mApple, mFile, mEdit, mLight,mSendEvent };	/* four menus */
};


resource 'MENU' (mApple, preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About Traffic Light 2.0",	noicon, nokey, nomark, plain;
		"-",						noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile, textMenuProc,
	MenuItem12 | MenuItem4 | MenuItem5 | MenuItem9 | MenuItem10,
	enabled, "File",
	{
		"New",			noicon, "N", nomark, plain;
		"Open",		noicon, "O", nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Close",		noicon, "W", nomark, plain;
		"Save",			noicon, "S", nomark, plain;
		"Save As",		noicon, nokey, nomark, plain;
		"Revert",		noicon, nokey, nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Page Setup",	noicon, nokey, nomark, plain;
		"Print",		noicon, nokey, nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Quit",			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (mEdit, preload) {
	mEdit, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "Edit",
	 {
		"Undo",			noicon, "Z", nomark, plain;
		"-",			noicon, nokey, nomark, plain;
		"Cut",			noicon, "X", nomark, plain;
		"Copy",			noicon, "C", nomark, plain;
		"Paste",		noicon, "V", nomark, plain;
		"Clear",		noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mLight, preload) {
	mLight, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "Traffic",
	 {
		"Red Light",	noicon, nokey, nomark, plain;
		"Green Light",	noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mSendEvent, preload) {
	mSendEvent, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "Apple Events",
	 {
		"Send messages to Self",		noicon, nokey, nomark, plain;
		"-",							noicon, nokey, nomark, plain;
		"Send a close message",			noicon, nokey, nomark, plain;
		"Send a MoveWindow message",	noicon, "M", nomark, plain;
		"-",							noicon, nokey, nomark, plain;
		"Speed Test",					noicon, "T", nomark, plain;
		"Use No Reply mode",			noicon, "1", nomark, plain;
		"Use Wait Reply mode",		noicon, "2", nomark, plain;
		"Use Queue Reply mode",		noicon, "3", nomark, plain;
	}
};



/* this ALRT and DITL are used as an About screen */

resource 'ALRT' (rAboutAlert, purgeable) {
	{40, 20, 160, 290},
	rAboutAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};

resource 'DLOG' (ERR_DLOG_ID, purgeable) {
	{40, 20, 240, 290},
	dBoxProc,
	invisible,
	noGoAway,
	0,
	ERR_DLOG_ID,
	"No Name City"
};

resource 'DITL' (ERR_DLOG_ID, purgeable) {
	{
		{176, 180, 196, 260},	Button { enabled, "OK" },
		{5, 4, 170, 265},		UserItem { disabled },
	}
};


resource 'DLOG' (ELAPSED_DLOG_ID,purgeable) {
	{40, 20, 240, 290},
	dBoxProc,
	invisible,
	noGoAway,
	0,
	ELAPSED_DLOG_ID,
	"No Name City"
};

resource 'DITL' (ELAPSED_DLOG_ID, purgeable) {
	{
		{176, 180, 196, 260},	Button { enabled, "OK" },
		{4, 4, 170, 265},		StaticText { disabled, "^0^1" },
	}
};


resource 'DITL' (rAboutAlert, purgeable) {
	{ /* array DITLarray: 5 elements */
		{88, 180, 108, 260},	Button { enabled, "OK" },
		{8, 8, 24, 260},		StaticText { disabled, "Traffic Light (6.0.x & 7.0 compatible)" },
		{32, 8, 48, 260},		StaticText { disabled, "Copyright  1988-91 Apple Computer" },
		{56, 8, 72, 136},		StaticText { disabled, "Brought to you by:" },
		{80, 24, 112, 167},		StaticText { disabled, "Macintosh Developer Technical Support" }
	}
};


/* this ALRT and DITL are used as an error screen */

resource 'ALRT' (rUserAlert, purgeable) {
	{40, 20, 120, 260},
	rUserAlert,
	{
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent,
		OK, visible, silent
	}
};


resource 'DITL' (rUserAlert, purgeable) {
	{
		{50, 150, 70, 230},	Button { enabled, "OK" },
		{10, 60, 30, 230},	StaticText { disabled, "Sample - Error occurred!" },
		{8, 8, 40, 40},		Icon { disabled, 2 }
	}
};


resource 'WIND' (rWindow, preload, purgeable) {
	{60, 40, 290, 160},
	noGrowDocProc, invisible, goAway, 0x0, "Traffic"
};

resource 'RECT' (rStopRect, preload, purgeable) {
	{10, 10, 110, 110}
};

resource 'RECT' (rGoRect, preload, purgeable) {
	{120, 10, 220, 110}
};


/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* Can properly use background null events	*/
	doesActivateOnFGSwitch,		/* We do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* This is definitely not a background-only application! */
	dontGetFrontClicks,			/* Change this is if you want "do first click" behavior like the Finder */
	ignoreAppDiedEvents,		/* Essentially, I'm not a debugger (sub-launching) */
	is32BitCompatible,			/* This app can be run in 32-bit address space */
	isHighLevelEventAware,		/* does Post/AcceptHighLevelEvent */
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024
};

resource 'SIZE' (0) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	doesActivateOnFGSwitch,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	dontGetFrontClicks,			/* change this is if you want "do first click" behavior like the Finder */
	ignoreAppDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	not32BitCompatible,			/* this app should not be run in 32-bit address space */
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024
};



resource 'STR#' (kMiscStrings, purgeable) {
	{
		"Save File As:",
		"Untitled",
	}
};

resource 'STR#'(ERR_DLOG_ID, purgeable) {
	{
/* [1] */	"An Error has occurred.",
/* [2] */	"Error #",
/* [3] */	"what: ",
/* [4] */	"message: ",
/* [5] */	"msgID: ",
	}
};

resource 'STR#'(ELAPSED_DLOG_ID, purgeable) {
	{
/* [1] */	"Elapsed Time: ",
	}
};


type 'DTS ' as 'STR ';

resource 'DTS ' (0) {
	"Sample - Version 2.0 Modified for System 7.0"
};

resource 'vers' (1, purgeable) {
	0x02,
	0x00,
	beta,
	0x02,
	verUs,
	"2.0 b2",
	"2.0 b2, Sample - Modified for System 7.0"
};

resource 'FREF' (129) {
	'BOOL',
	1,
	""
};


resource 'FREF' (128) {
	'APPL',
	0,
	""
};


resource 'BNDL' (128) {
	'DTS ', 0, {
		'ICN#', { 0, 128, 1, 129 },
		'FREF', { 0, 128, 1, 129 }
	}
};

resource 'ICN#' (128) {
	{
		$"00FF F800 0100 0400 0200 0200 040F 0100"
		$"041F 8100 043F C100 047F E100 04FF F100"
		$"04FF F100 04FF F100 04FF F100 047F E100"
		$"043F C100 041F 8100 040F 3F00 0400 4080"
		$"0400 8040 040F 3020 0411 C810 042E 7F8F"
		$"0442 3007 0481 0007 0480 8007 0480 6007"
		$"0480 1FE7 0440 211F 0420 4107 0410 8100"
		$"040F 0100 0200 0200 0100 0400 00FF F800",

		$"00FF F800 01FF FC00 03FF FE00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF80"
		$"07FF FFC0 07FF FFE0 07FF FFF0 07FF FFFF"
		$"07FF FFFF 07FF FFFF 07FF FFFF 07FF FFFF"
		$"07FF FFFF 07FF FF1F 07FF FF07 07FF FF00"
		$"07FF FF00 03FF FE00 01FF FC00 00FF F800"
	}
};

resource 'ICN#' (129) {
	{
		$"00FF F800 0100 0400 0200 0200 040F 0100"
		$"041F 8100 043F C100 047F E100 04FF F100"
		$"04FF F100 04FF F100 04FF F100 047F E100"
		$"043F C100 041F 8100 040F 0100 0400 0100"
		$"0400 0100 040F 0100 0410 8100 0420 4100"
		$"0440 2100 0480 1100 0480 1100 0480 1100"
		$"0480 1100 0440 2100 0420 4100 0410 8100"
		$"040F 0100 0200 0200 0100 0400 00FF F800",

		$"00FF F800 01FF FC00 03FF FE00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 07FF FF00 07FF FF00 07FF FF00"
		$"07FF FF00 03FF FE00 01FF FC00 00FF F800"
	}
};


// This really messes up 7.0a12, so I've commented it out.

//data 'ics#' (128) {
//	$"0000 0000 0000 0000 0000 0000 0000 0000"            /* ................ */
//	$"0000 0000 0000 0000 0000 0000 0000 0000"            /* ................ */
//	$"0000 0000 0000 0000 0000 0000 0000 0000"            /* ................ */
//	$"0000 0000 0000 0000 0000 0000 0000 0000"            /* ................ */
//};

data 'icl4' (128) {
	$"0000 0000 FFFF FFFF FFFF F000 0000 0000"            /* ................ */
	$"0000 000F DDDD DDDD DDDD DF00 0000 0000"            /* ................ */
	$"0000 00FD DDDD DDDD DDDD DDF0 0000 0000"            /* ................ */
	$"0000 0FDD DDDD 3333 DDDD DDDF 0000 0000"            /* ......33........ */
	$"0000 0FDD DDD3 3333 3DDD DDDF 0000 0000"            /* .....33=....... */
	$"0000 0FDD DD33 3333 33DD DDDF 0000 0000"            /* .....3333....... */
	$"0000 0FDD D333 3333 333D DDDF 0000 0000"            /* ....3333=...... */
	$"0000 0FDD 3333 3333 3333 DDDF 0000 0000"            /* ....333333...... */
	$"0000 0FDD 3333 3333 3333 DDDF 0000 0000"            /* ....333333...... */
	$"0000 0FDD 3333 3333 3333 DDDF 0000 0000"            /* ....333333...... */
	$"0000 0FDD 3333 3333 3333 DDDF 0000 0000"            /* ....333333...... */
	$"0000 0FDD D333 3333 333D DDDF 0000 0000"            /* ....3333=...... */
	$"0000 0FDD DD33 3333 33DD DDDF 0000 0000"            /* .....3333....... */
	$"0000 0FDD DDD3 3333 3DDD DDDF 0000 0000"            /* .....33=....... */
	$"0000 0FDD DDDD 3333 DDFF FFFF 0000 0000"            /* ......33........ */
	$"0000 0FDD DDDD DDDD DF00 0000 F000 0000"            /* ................ */
	$"0000 0FDD DDDD DDDD F000 0000 0F00 0000"            /* ................ */
	$"0000 0FDD DDDD 888F 00FF 0000 00F0 0000"            /* .............. */
	$"0000 0FDD DDD8 888F FF00 F000 000F 0000"            /* .....؈........ */
	$"0000 0FDD DD88 FFF0 0FFF FFFF F000 FFFF"            /* ............... */
	$"0000 0FDD D888 88F0 00FF 0000 0000 0FFF"            /* ....؈......... */
	$"0000 0FDD 8888 888F 0000 0000 0000 0FFF"            /* ............ */
	$"0000 0FDD 8888 8888 F000 0000 0000 0FFF"            /* ............ */
	$"0000 0FDD 8888 8888 8FF0 0000 0000 0FFF"            /* ........... */
	$"0000 0FDD 8888 8888 888F FFFF FFF0 0FFF"            /* .......... */
	$"0000 0FDD D888 8888 888D DDDF 000F FFFF"            /* ....؈...... */
	$"0000 0FDD DD88 8888 88DD DDDF 0000 0FFF"            /* ............ */
	$"0000 0FDD DDD8 8888 8DDD DDDF 0000 0000"            /* .....؈....... */
	$"0000 0FDD DDDD 8888 DDDD DDDF 0000 0000"            /* .............. */
	$"0000 00FD DDDD DDDD DDDD DDF0 0000 0000"            /* ................ */
	$"0000 000F DDDD DDDD DDDD DF00 0000 0000"            /* ................ */
	$"0000 0000 FFFF FFFF FFFF F000 0000 0000"            /* ................ */
};

data 'icl8' (128) {
	$"0000 0000 0000 0000 FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FF00 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 00FF FAFA FAFA FAFA FAFA"            /* ................ */
	$"FAFA FAFA FAFF 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 FFFA FAFA FAFA FAFA FAFA"            /* ................ */
	$"FAFA FAFA FAFA FF00 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAFA D7D7 D7D7"            /* ............ */
	$"FAFA FAFA FAFA FAFF 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAD7 D7D7 D7D7"            /* ........... */
	$"D7FA FAFA FAFA FAFF 0000 0000 0000 0000"            /* ............... */
	$"0000 0000 00FF FAFA FAFA D7D7 D7D7 D7D7"            /* .......... */
	$"D7D7 FAFA FAFA FAFF 0000 0000 0000 0000"            /* .............. */
	$"0000 0000 00FF FAFA FAD7 D7D7 D7D7 D7D7"            /* ......... */
	$"D7D7 D7FA FAFA FAFF 0000 0000 0000 0000"            /* ............. */
	$"0000 0000 00FF FAFA D7D7 D7D7 D7D7 1D1D"            /* .......... */
	$"D7D7 D7D7 FAFA FAFF 0000 0000 0000 0000"            /* ............ */
	$"0000 0000 00FF FAFA D7D7 D7D7 D7D7 1D1D"            /* .......... */
	$"D7D7 D7D7 FAFA FAFF 0000 0000 0000 0000"            /* ............ */
	$"0000 0000 00FF FAFA D7D7 D7D7 D7D7 D7D7"            /* ........ */
	$"D7D7 D7D7 FAFA FAFF 0000 0000 0000 0000"            /* ............ */
	$"0000 0000 00FF FAFA D7D7 D7D7 D7D7 D7D7"            /* ........ */
	$"D7D7 D7D7 FAFA FAFF 0000 0000 0000 0000"            /* ............ */
	$"0000 0000 00FF FAFA FAD7 D7D7 D7D7 D7D7"            /* ......... */
	$"D7D7 D7FA FAFA FAFF 0000 0000 0000 0000"            /* ............. */
	$"0000 0000 00FF FAFA FAFA D7D7 D7D7 D7D7"            /* .......... */
	$"D7D7 FAFA FAFA FAFF 0000 0000 0000 0000"            /* .............. */
	$"0000 0000 00FF FAFA FAFA FAD7 D7D7 D7D7"            /* ........... */
	$"D7FA FAFA FAFA FAFF 0000 0000 0000 0000"            /* ............... */
	$"0000 0000 00FF FAFA FAFA FAFA D7D7 D7D7"            /* ............ */
	$"FAFA F4F4 FFFF FFFF 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAFA FAFA FAFA"            /* ................ */
	$"FAF4 0707 0707 0707 FF00 0000 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAFA FAFA FAFA"            /* ................ */
	$"FF07 0707 0707 0707 07FF 0000 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAFA E7E7 E7F4"            /* ................ */
	$"0707 FFFF 0707 0707 0707 FF00 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA FAE7 BFBF BFF4"            /* ............. */
	$"F4F4 0000 F407 0707 0707 07FF 0000 0000"            /* ................ */
	$"0000 0000 00FF FAFA FAFA E7BF FFFF FF07"            /* ............... */
	$"07F4 F4F4 F4F4 F4F4 F407 0707 FFFF FFFF"            /* ................ */
	$"0000 0000 00FF FAFA FAE7 BFBF BFBF FF07"            /* ............ */
	$"0707 F4F4 0707 0707 0707 0707 07FF FFFF"            /* ................ */
	$"0000 0000 00FF FAFA E7BF BFBF BFBF BFFF"            /* .......... */
	$"0707 0707 0707 0707 0707 0707 07FF FFFF"            /* ................ */
	$"0000 0000 00FF FAFA E7BF BFBF BFBF BFBF"            /* ......... */
	$"FF07 0707 0707 0707 0707 0707 07FF FFFF"            /* ................ */
	$"0000 0000 00FF FAFA E7BF BFBF BFBF BFBF"            /* ......... */
	$"BFFF FF07 0707 0707 0707 0707 07FF FFFF"            /* ............... */
	$"0000 0000 00FF FAFA E7BF BFBF BFBF BFBF"            /* ......... */
	$"BFBF BFFF FFFF FFFF FFFF FF07 07FF FFFF"            /* ............. */
	$"0000 0000 00FF FAFA FABF BFBF BFBF BFBF"            /* ......... */
	$"BFBF BFFA FAFA FAFF 0000 00FF FFFF FFFF"            /* ............. */
	$"0000 0000 00FF FAFA FAFA BFBF BFBF BFBF"            /* .......... */
	$"BFBF FAFA FAFA FAFF 0000 0000 00FF FFFF"            /* .............. */
	$"0000 0000 00FF FAFA FAFA FABF BFBF BFBF"            /* ........... */
	$"BFFA FAFA FAFA FAFF 0000 0000 0000 0000"            /* ............... */
	$"0000 0000 00FF FAFA FAFA FAFA BFBF BFBF"            /* ............ */
	$"FAFA FAFA FAFA FAFF 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 FFFA FAFA FAFA FAFA FAFA"            /* ................ */
	$"FAFA FAFA FAFA FF00 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 00FF FAFA FAFA FAFA FAFA"            /* ................ */
	$"FAFA FAFA FAFF 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 0000 FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FF00 0000 0000 0000 0000 0000"            /* ................ */
};

resource 'CURS' (oappCursor) {
	$"0000 0000 38F0 4510 4510 4530 38D0 0000"
	$"0000 79E0 4510 4510 4510 79E0 4100 4100",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (odocCursor) {
	$"0010 0010 38F0 4510 4510 4510 38F0 0000"
	$"0000 0000 38E0 4510 4500 4500 38F0 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (pdocCursor) {
	$"0010 0010 78F0 4510 4510 4510 78F0 4000"
	$"4000 0000 38E0 4510 4500 4500 38F0 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (quitCursor) {
	$"0000 0000 3D10 4510 4510 4510 3CE0 0400"
	$"1440 0040 10E0 1040 1040 1040 1030 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (ansrCursor) {
	$"0000 0000 3D60 4590 4510 4D10 3510 0000"
	$"0000 0000 3D60 4190 3900 0500 7900 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (mvfwCursor) {
	$"0000 0000 7910 5510 5510 54A0 5440 0000"
	$"1000 2800 2150 7150 2150 2150 20A0 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};

resource 'CURS' (echoCursor) {
	$"0000 0000 38E0 4510 7D00 4100 38F0 0000"
	$"4000 4000 58E0 6510 4510 4510 44E0 0000",
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF",
	{8, 6}
};



/****************** Help Resources added by Zz *******************************/
resource 'STR#' (mApple) {
	{
/*  1 */	"Displays version and other information about this application."
	};
};


resource 'hmnu' (mApple, "\0x14") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Menu title */
		HMStringResItem {
			mApple,0,				/* menu item message					*/
			mApple,0,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		},

		/* About item */
		HMStringResItem {
			mApple,1,				/* menu item message					*/
			mApple,1,				/* disabled item message				*/
			mApple,0,				/* reserved message						*/
			mApple,0				/* reserved message						*/
		}
	};
};

resource 'STR#' (mFile) {
	{
/*  1 */	"Operations related to file handling.",

/*  2 */	"Creates a new file.",
/*  3 */	"Creates a new file.  To enable this item, choose Close from the File menu.",
/*  4 */	"Opens an existing file.",
/*  5 */	"Opens an existing file.  To enable this item, choose Close from the File menu.",
/*  6 */	"Closes the current file.",
/*  7 */	"Closes the current file.  To enable this item, choose New or Open from the "
			"File menu.",
/*  8 */	"Saves the current file.",
/*  9 */	"Saves the current file.  To enable this item, choose New or Open from the "
			"File menu.",
/* 10 */	"Saves the current file under a different name.",
/* 11 */	"Saves the current file under a different name.  (Not currently supported by "
			"this application)",
/* 12 */	"Reverts to the last saved version of the current file.",
/* 13 */	"Reverts to the last saved version of the current file.  (Not currently "
			"supported by this application)",
/* 14 */	"Sets up paper size, orientation, and other printing options.",
/* 15 */	"Sets up paper size, orientation, and other printing options.  To enable "
			"this item, choose New or Open from the File menu.",
/* 16 */	"Prints all or part of the current file.",
/* 17 */	"Prints all or part of the current file.  To enable this item, choose New "
			"or Open from the File menu.",
/* 18 */	"Quit from this application."
	}
};

resource 'hmnu' (mFile, "File") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* File */
		HMStringResItem {
			mFile,1,				/* menu title message					*/
			mFile,1,				/* disabled title message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* New */
		HMStringResItem {
			mFile,2,				/* menu item message					*/
			mFile,3,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Open */
		HMStringResItem {
			mFile,4,				/* menu item message					*/
			mFile,5,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Close */
		HMStringResItem {
			mFile,6,				/* menu item message					*/
			mFile,7,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save */
		HMStringResItem {
			mFile,8,				/* menu item message					*/
			mFile,9,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Save As */
		HMStringResItem {
			mFile,10,				/* menu item message					*/
			mFile,11,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Revert */
		HMStringResItem {
			mFile,12,				/* menu item message					*/
			mFile,13,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Page Setup */
		HMStringResItem {
			mFile,14,				/* menu item message					*/
			mFile,15,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Print */
		HMStringResItem {
			mFile,16,				/* menu item message					*/
			mFile,17,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Quit */
		HMStringResItem {
			mFile,18,				/* menu item message					*/
			mFile,0,				/* disabled item message				*/
			mFile,0,				/* reserved message						*/
			mFile,0					/* reserved message						*/
		}
	}
};


resource 'STR#' (mEdit) {
	{
/*  1 */	"Editing operations.",

/*  2 */	"Undo the last operation.",
/*  3 */	"Undo the last operation.  (Not currently supported by this application)",
/*  4 */	"Cuts the current selection.",
/*  5 */	"Cuts the current selection.  (Not currently supported by this application)",
/*  6 */	"Copies the current selection.",
/*  7 */	"Copies the current selection.  (Not currently supported by this application)",
/*  8 */	"Pastes the current selection.",
/*  9 */	"Pastes the current selection.  (Not currently supported by this application)",
/* 10 */	"Clears the current selection.",
/* 11 */	"Clears the current selection.  (Not currently supported by this application)"
	}
};

resource 'hmnu' (mEdit, "Edit") {
	HelpMgrVersion,					/* Help Version							*/
	0,								/* options								*/
	0,								/* theProc								*/
	0,								/* variant								*/
	HMSkipItem {					/* skip missing msg						*/
		},
	{
		/* Edit */
		HMStringResItem {
			mEdit,1,				/* menu title message					*/
			mEdit,1,				/* disabled title message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Undo */
		HMStringResItem {
			mEdit,2,				/* menu item message					*/
			mEdit,3,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Disabled Line */
		HMSkipItem {				/* skip missing msg						*/
		},

		/* Cut */
		HMStringResItem {
			mEdit,4,				/* menu item message					*/
			mEdit,5,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Copy */
		HMStringResItem {
			mEdit,6,				/* menu item message					*/
			mEdit,7,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Paste */
		HMStringResItem {
			mEdit,8,				/* menu item message					*/
			mEdit,9,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		},

		/* Clear */
		HMStringResItem {
			mEdit,10,				/* menu item message					*/
			mEdit,11,				/* disabled item message				*/
			mEdit,0,				/* reserved message						*/
			mEdit,0					/* reserved message						*/
		}

	}
};


resource 'STR#' (mLight, "Traffic") {
	{
/*  1 */	"Control the traffic light window.",

/*  2 */	"Make the light red.",
/*  3 */	"Make the light red.  To enable this item, choose New or Open from the File menu.",
/*  4 */	"Make the light red.  The item is checked now because the light is already red.",

/*  5 */	"Make the light green.",
/*  6 */	"Make the light green.  To enable this item, choose New or Open from the File menu.",
/*  7 */	"Make the light green.  The item is checked now because the light is already green."
	}
};

resource 'hmnu' (mLight, "Traffic") {
	HelpMgrVersion,						/* Help Version							*/
	0,									/* options								*/
	0,									/* theProc								*/
	0,									/* variant								*/
	HMSkipItem {						/* skip missing msg						*/
		},
	{
		/* Traffic */
		HMStringResItem {
			mLight,1,					/* menu title message					*/
			mLight,1,					/* disabled title message				*/
			mLight,0,					/* reserved message						*/
			mLight,0					/* reserved message						*/
		},

		/* Red */
		HMStringResItem {
			mLight,2,					/* menu item message					*/
			mLight,3,					/* disabled item message				*/
			mLight,4,					/* checked message						*/
			mLight,0					/* reserved message						*/
		},

		/* Green */
		HMStringResItem {
			mLight,5,					/* menu item message					*/
			mLight,6,					/* disabled item message				*/
			mLight,7,					/* reserved message						*/
			mLight,0					/* reserved message						*/
		}
	}
};


resource 'STR#' (mSendEvent, "Apple Events") {
	{
/*  1 */	"Operations related to Apple Events.  This includes sending events to "
			"applications, as well as choosing the application to recieve the events.",
/*  2 */	"The target of these AppleEvent messages is determined by selecting an "
			"application from a dialog box. Selecting this item causes the target "
			"to be this application only.",
/*  3 */	"The target of these AppleEvent messages is currently this application. "
			"Selecting this item will allow you to choose the target application "
			"from a dialog box.",
/*  4 */	"Send a Close message to this application.",
/*  5 */	"Send a Close message to this application. (Sorry, but I have no idea "
			"why this is disabled or how to enable it)",
/*  6 */	"Send a MoveWindow message to this application.",
/*  7 */	"Send a MoveWindow message to this application.  To enable this item, "
			"choose New or Open from the File menu.",
/*  8 */	"Select this item to send 1000 empty AppleEvent messages and see how "
			"long it takes.",
/*  9 */	"Modifies the Speed Test to use the No reply mode of AESend.",
/* 10 */	"Modifies the Speed Test to use the Wait reply mode of AESend.",
/* 11 */	"Modifies the Speed Test to use the Queue reply mode of AESend.",
	}
};


resource 'hmnu' (mSendEvent, "Apple Events") {
	HelpMgrVersion,						/* Help Version							*/
	0,									/* options								*/
	0,									/* theProc								*/
	0,									/* variant								*/
	HMSkipItem {						/* skip missing msg						*/
		},
	{
		/* Apple Events */
		HMStringResItem {
			mSendEvent,1,				/* menu title message					*/
			mSendEvent,1,				/* disabled title message				*/
			mSendEvent,0,				/* reserved message						*/
			mSendEvent,0				/* reserved message						*/
		},

		/* Choose target */
		HMStringResItem {
			mSendEvent,2,				/* menu item message					*/
			mSendEvent,0,				/* disabled item message				*/
			mSendEvent,3,				/* enabled and checked					*/
			mSendEvent,0				/* enabled and other					*/
		},

		/* Disabled Line */
		HMSkipItem {					/* skip missing msg						*/
		},

		/* Send a Close message */
		HMStringResItem {
			mSendEvent,4,				/* menu item message					*/
			mSendEvent,5,				/* disabled item message				*/
			mSendEvent,0,				/* reserved message						*/
			mSendEvent,0				/* reserved message						*/
		},

		/* Send a MoveWindow message */
		HMStringResItem {
			mSendEvent,6,				/* menu item message					*/
			mSendEvent,7,				/* disabled item message				*/
			mSendEvent,0,				/* reserved message						*/
			mSendEvent,0				/* reserved message						*/
		},
		
		/* Disabled Line */
		HMSkipItem {					/* skip missing msg						*/
		},

		/* Speed Test */
		HMStringResItem {
			mSendEvent,8,				/* menu item message					*/
			mSendEvent,0,				/* disabled item message				*/
			mSendEvent,0,				/* reserved message						*/
			mSendEvent,0				/* reserved message						*/
		},

		/* Speed Test */
		HMStringResItem {
			mSendEvent,9,				/* menu item message					*/
			mSendEvent,0,				/* disabled item message				*/
			mSendEvent,9,				/* checked message						*/
			mSendEvent,0				/* reserved message						*/
		},

		/* Speed Test */
		HMStringResItem {
			mSendEvent,10,				/* menu item message					*/
			mSendEvent,0,				/* disabled item message				*/
			mSendEvent,10,				/* checked message						*/
			mSendEvent,0				/* reserved message						*/
		},

		/* Speed Test */
		HMStringResItem {
			mSendEvent,11,				/* menu item message					*/
			mSendEvent,0,				/* disabled item message				*/
			mSendEvent,11,				/* checked message						*/
			mSendEvent,0				/* reserved message						*/
		},

	}
};


/************* hwin resource for the Traffic Light window *************************/
resource 'hwin' (rWindow, preload) {
	HelpMgrVersion,			/* Help Version							*/
	0,						/* options								*/
	{
		rWindow, 			/* ID of help resource to be used. 			*/
		'hrct', 			/* Type of help resource to be used. 		*/
		7, 					/* Length to use when comparing titles. 	*/
		"Untitled"			/* Name of window attached to this resource. */
	}
};

resource 'hrct' (rWindow, preload) {
	HelpMgrVersion,			/* Help Version							*/
	0,						/* options								*/
	0,
	0,
	{

		HMStringItem {
			{115, 60},
			{0, 0, 230, 120},
			"Click anywhere in this window to change the traffic signal."
		}
	}
};
